$var-map: ();

@mixin setv($new-vars){

    :root {
        // each item in color map
        @each $name, $value in $new-vars {
            --v-#{$name}: $value;
        }
    }

    // merge / overwrite 
    $var-map: map-merge($var-map, $new-vars) !global;
}

@function v($name, $true-value: false) {

    // if has been requested the true value
    @if $true-value == true {

        // return directly from the $var-map
        @if map-has-key($var-map, $name) {
            @return map-get($var-map, $name);
        }

        // show a warning if not found
        @warn "Unknown `#{$name}` in $var-map.";
        @return null;
    }

    // else return the vanilla formula "var(--v-name)"
    @else {
        @return var(--v-#{$name});
    }
}